import { Optional, OptionalAble } from "./optional";
import { Failure } from "../";
import { IJSONEncodable } from "../codable";
export declare class None<T> implements OptionalAble<T>, IJSONEncodable {
    private constructor();
    static readonly instance: None<unknown>;
    get get(): T;
    readonly value: T | null;
    readonly clone: None<T>;
    getOrElse(defaultValue: T): T;
    orElse(defaultValue: Optional<T>): Optional<T>;
    isDefined: boolean;
    isEmpty: boolean;
    map<U>(f: (value: T) => U): Optional<U>;
    flatMap<U>(f: (value: T) => Optional<U>): Optional<U>;
    equals(compared: Optional<T> | T, _?: (a: T, b: T) => boolean): boolean;
    fold<U>(left: () => U, right: (value: T) => U): U;
    unwrap(or: Error): T;
    toEither<E>(error: E): Failure<E, T>;
    get json(): unknown;
    compare(_: Optional<T>): boolean;
    get hashValue(): string;
}
export declare function none<T>(): None<T>;
